unit Settings;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, UITypes,
  Dialogs, StdCtrls, Data.DB, Data.Win.ADODB, Vcl.Samples.Spin, QueryEmails;

Const
    STR_PROGRAM_NAME = 'Registration Tool';

    STR_EMAIL_ACCOUNT_SECURITY_NONE = 'EMAIL_ACCOUNT_SECURITY_NONE';
    STR_EMAIL_ACCOUNT_SECURITY_SSLTLS = 'EMAIL_ACCOUNT_SECURITY_SSLTLS';

    STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv2 = 'EMAIL_ACCOUNT_SECURITY_METHOD_sslvSSLv2';
    STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv23 = 'EMAIL_ACCOUNT_SECURITY_METHOD_sslvSSLv23';
    STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv3 = 'EMAIL_ACCOUNT_SECURITY_METHOD_sslvSSLv3';
    STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1 = 'EMAIL_ACCOUNT_SECURITY_METHOD_sslvTLSv1';
    STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_1 = 'EMAIL_ACCOUNT_SECURITY_METHOD_sslvTLSv1_1';
    STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_2 = 'EMAIL_ACCOUNT_SECURITY_METHOD_sslvTLSv1_2';

    STR_EMAIL_ACCOUNT_SERVER_TYPE_asPOP3 = 'EMAIL_ACCOUNT_SERVER_TYPE_asPOP3';
    STR_EMAIL_ACCOUNT_SERVER_TYPE_asIMAP = 'EMAIL_ACCOUNT_SERVER_TYPE_asIMAP';
    STR_EMAIL_ACCOUNT_SERVER_TYPE_asSMTP = 'EMAIL_ACCOUNT_SERVER_TYPE_asSMTP';

type
  TFormSettings = class(TForm)
    GroupBoxContainer: TGroupBox;
    GroupBoxMySQL: TGroupBox;
    LabelMySQLConnectionString: TLabel;
    EditMySQLConnectionString: TEdit;
    ButtonCancel: TButton;
    ButtonOK: TButton;
    EditDatabaseNameToUse: TEdit;
    LabelDatabaseToUse: TLabel;
    Button1: TButton;
    ADOConnection: TADOConnection;
    GroupBox1: TGroupBox;
    CheckBoxRunWithWindows: TCheckBox;
    GroupBox2: TGroupBox;
    SpinEditScanTimerMins: TSpinEdit;
    Label2: TLabel;
    Label1: TLabel;
    Button2: TButton;
    GroupBox3: TGroupBox;
    Button3: TButton;
    Label3: TLabel;
    EditSenderEmail: TEdit;
    GroupBox4: TGroupBox;
    Label4: TLabel;
    EditForwardAddress: TEdit;
    DataSource: TDataSource;
    ADOQuery: TADOQuery;
    Label5: TLabel;
    Label6: TLabel;
    Button4: TButton;
    Label7: TLabel;
    EditSupportAddress: TEdit;
    Label8: TLabel;
    GroupBox5: TGroupBox;
    Label9: TLabel;
    EditLogFileName: TEdit;
    Button5: TButton;
    SaveDialog1: TSaveDialog;
    CheckBoxLogDebug: TCheckBox;
    EditMonthlyLogFolder: TEdit;
    Button6: TButton;
    Label10: TLabel;
    OpenDialog1: TOpenDialog;
    Label11: TLabel;
    EditAllBundleProductName: TEdit;
    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBoxRunWithWindowsClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    IncomingEmailAccount: TAccountItemData;
    IncomingEmailAccountVersionCodes: TAccountItemData;
    OutgoingEmailAccount: TAccountItemData;
    { Public declarations }
    procedure SaveSettings;
    procedure LoadSettings;
    procedure CheckBoxRunWithWindowsGet;
    function StoreSettingsInDataBase: Boolean;
    function LoadSettingsFromDataBase: Boolean;
  end;

    function GetSettingsFileName: String;

var
  FormSettings: TFormSettings;

implementation

{$R *.dfm}

Uses
    SpecialFolders,
    SHFolder,
    IniFiles,
    Helper3delite,
    Helper3deliteWin,
    IdSSLOpenSSL,
    Main,
    Registry,
    EmailAccountSettings,
    SMTPAccountSettings,
    //FileCtrl,
    StrEncoder;

function GetSettingsFileName: String;
var
    SettingsFolder: String;
begin
    try
        SettingsFolder := GetSpecialFolder(CSIDL_LOCAL_APPDATA);
        SettingsFolder := SettingsFolder + '\3delite\Registration Tool\';
        SysUtils.ForceDirectories(SettingsFolder);
        Result := SettingsFolder + ChangeFileExt(ExtractFileName(Application.ExeName), '.ini');
    except
        //*
    end;
end;

function GetLogFolder: String;
var
    LogsFolder: String;
begin
    try
        LogsFolder := GetSpecialFolder(CSIDL_PERSONAL);
        LogsFolder := LogsFolder + '\3delite\Registration Tool Logs\';
        SysUtils.ForceDirectories(LogsFolder);
        Result := LogsFolder;
    except
        //*
    end;
end;

procedure TFormSettings.Button1Click(Sender: TObject);
begin
    try
        Screen.Cursor := crAppStart;
        ADOConnection.Close;
        ADOConnection.ConnectionString := EditMySQLConnectionString.Text;
        ADOConnection.Open;
        ADOConnection.Close;
        Screen.Cursor := crDefault;
        MessageDlg('Connection successful.', mtInformation, [mbOk], 0);
    except
        on E: Exception do begin
            Screen.Cursor := crDefault;
            MessageDlg('Error connecting: ' + E.Message, mtError, [mbOk], 0);
        end;
    end;
end;

procedure TFormSettings.Button2Click(Sender: TObject);
var
    FormEditAccount: TFormEditAccount;
begin
    FormEditAccount := TFormEditAccount.Create(Self);
    try
        FormEditAccount.AccountItemData := IncomingEmailAccount;
        if FormEditAccount.ShowModal = mrOk then begin

        end;
    finally
        FreeAndNil(FormEditAccount);
    end;
end;

procedure TFormSettings.Button3Click(Sender: TObject);
var
    FormEditSMTPAccount: TFormEditSMTPAccount;
begin
    FormEditSMTPAccount := TFormEditSMTPAccount.Create(Self);
    try
        FormEditSMTPAccount.AccountItemData := OutgoingEmailAccount;
        if FormEditSMTPAccount.ShowModal = mrOk then begin

        end;
    finally
        FreeAndNil(FormEditSMTPAccount);
    end;
end;

procedure TFormSettings.Button4Click(Sender: TObject);
var
    FormEditAccount: TFormEditAccount;
begin
    FormEditAccount := TFormEditAccount.Create(Self);
    try
        FormEditAccount.AccountItemData := IncomingEmailAccountVersionCodes;
        if FormEditAccount.ShowModal = mrOk then begin

        end;
    finally
        FreeAndNil(FormEditAccount);
    end;
end;

procedure TFormSettings.Button5Click(Sender: TObject);
begin
    SaveDialog1.FileName := EditLogFileName.Text;
    if SaveDialog1.Execute then begin
        EditLogFileName.Text := SaveDialog1.FileName;
    end;
end;

procedure TFormSettings.Button6Click(Sender: TObject);
begin
    with TFileOpenDialog.Create(nil) do begin
        try
            Title := 'Select folder';
            Options := [fdoPickFolders, fdoPathMustExist, fdoForceFileSystem];
            OkButtonLabel := 'Select';
            DefaultFolder := EditMonthlyLogFolder.Text;
            FileName := EditMonthlyLogFolder.Text;
            if Execute then begin
                EditMonthlyLogFolder.Text := IncludeTrailingPathDelimiter(FileName);
            end;
        finally
            Free;
        end;
    end;
end;

procedure TFormSettings.ButtonCancelClick(Sender: TObject);
begin
    LoadSettings;
    LoadSettingsFromDataBase;
    Close;
end;

procedure TFormSettings.ButtonOKClick(Sender: TObject);
begin
    SaveSettings;
    try
        StoreSettingsInDataBase;
    except
        on E: Exception do begin
            MessageDlg('Error while saving settings: ' + E.Message, mtError, [mbOk], 0);
        end;
    end;
    Close;
    FormTool.ReloadProjectsWithExceptionHandling;
    FormTool.TimerCheckIncomingMail.Interval := SpinEditScanTimerMins.Value * 60 * 1000;
end;

procedure TFormSettings.CheckBoxRunWithWindowsClick(Sender: TObject);
// HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run
var
    Reg: TRegistry;
begin
    if RuningOn64BitOS then begin
        Reg := TRegistry.Create(KEY_WOW64_64KEY OR KEY_ALL_ACCESS);
    end else begin
        Reg := TRegistry.Create;
    end;
    try
        Reg.RootKey := HKEY_CURRENT_USER;
        if CheckBoxRunWithWindows.Checked then begin
            Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', True);
            Reg.WriteString(STR_PROGRAM_NAME, '"' + Application.ExeName + '" -startminimized');
        end else begin
            if Reg.KeyExists('Software\Microsoft\Windows\CurrentVersion\Run') then begin
                Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', True);
                Reg.DeleteValue(STR_PROGRAM_NAME);
            end;
        end;
    finally
        Reg.CloseKey;
        Reg.Free;
    end;
end;

procedure TFormSettings.CheckBoxRunWithWindowsGet;
// HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Run
var
    Reg: TRegistry;
begin
    if RuningOn64BitOS then begin
        Reg := TRegistry.Create(KEY_WOW64_64KEY OR KEY_ALL_ACCESS);
    end else begin
        Reg := TRegistry.Create;
    end;
    try
        Reg.RootKey := HKEY_CURRENT_USER;
        if Reg.KeyExists('Software\Microsoft\Windows\CurrentVersion\Run') then begin
            Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', True);
            CheckBoxRunWithWindows.Checked := Reg.ValueExists(STR_PROGRAM_NAME);
        end;
    finally
        Reg.CloseKey;
        Reg.Free;
    end;
end;

procedure TFormSettings.FormCreate(Sender: TObject);
begin
    IncomingEmailAccount := TAccountItemData.Create;
    IncomingEmailAccountVersionCodes := TAccountItemData.Create;
    OutgoingEmailAccount := TAccountItemData.Create;
    LoadSettings;
    CheckBoxRunWithWindowsGet;
    {
    try
        LoadSettingsFromDataBase;
    except
        on E: Exception do begin
            MessageDlg('Error while loading settings: ' + E.Message, mtError, [mbOk], 0);
        end;
    end;
    }
end;

procedure TFormSettings.FormDestroy(Sender: TObject);
begin
    FreeAndNil(IncomingEmailAccount);
    FreeAndNil(IncomingEmailAccountVersionCodes);
    FreeAndNil(OutgoingEmailAccount);
end;

procedure TFormSettings.SaveSettings;
var
    Ini: TIniFile;
    FileName: String;
begin
    try
        FileName := GetSettingsFileName;
        if NOT FileExists(FileName) then begin
            CreateUnicodeFile(FileName);
        end;
        Ini := TIniFile.Create(FileName);
        with Ini do begin
            WriteString('Settings', 'SQLConnectionString', EditMySQLConnectionString.Text);
            WriteString('Settings', 'SQLDatabaseToUse', EditDatabaseNameToUse.Text);
            WriteString('Settings', 'Log file name', EditLogFileName.Text);
            WriteString('Settings', 'Monthly log folder', IncludeTrailingPathDelimiter(EditMonthlyLogFolder.Text));
            WriteBool('Settings', 'Log debug', CheckBoxLogDebug.Checked);
        end;
    finally
        if Assigned(Ini)
            then FreeAndNil(Ini);
    end;
end;

procedure TFormSettings.LoadSettings;
var
    Ini: TIniFile;
    FileName: String;
begin
    try
        FileName := GetSettingsFileName;
        Ini := TIniFile.Create(FileName);
        with Ini do begin
            EditMySQLConnectionString.Text := ReadString('Settings', 'SQLConnectionString', StringReplace(EditMySQLConnectionString.Text, '(local)', GetComputerNameStr + '\SQLEXPRESS', [rfReplaceAll]));
            EditDatabaseNameToUse.Text := ReadString('Settings', 'SQLDatabaseToUse', EditDatabaseNameToUse.Text);
            EditLogFileName.Text := ReadString('Settings', 'Log file name', ChangeFileExt(GetSettingsFileName, ' Log.txt'));
            EditMonthlyLogFolder.Text := IncludeTrailingPathDelimiter(ReadString('Settings', 'Monthly log folder', GetLogFolder));
            CheckBoxLogDebug.Checked := ReadBool('Settings', 'Log debug', False);
        end;
    finally
        if Assigned(Ini)
            then FreeAndNil(Ini);
    end;
end;

function TFormSettings.StoreSettingsInDataBase: Boolean;
begin

    //Result := False;

    Screen.Cursor := crAppStart;
    try
        ADOConnection.Close;

        ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

        ADOQuery.SQL.Clear;

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + EditDatabaseNameToUse.Text + ';');

        //* Update the (hard-coded) current (CURRENT_SETTINGS_VERSION) record
        ADOQuery.SQL.Add('UPDATE ' + TN_SETTINGS);
        ADOQuery.SQL.Add('SET');

        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_CHECK_INTERVAL + ' = :CN_SETTINGS_EMAIL_CHECK_INTERVAL,');

        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_GUID + ' = :CN_SETTINGS_EMAIL_INCOMING_GUID,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_ItemName + ' = :CN_SETTINGS_EMAIL_INCOMING_ItemName,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_Active + ' = :CN_SETTINGS_EMAIL_INCOMING_Active,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_HostName + ' = :CN_SETTINGS_EMAIL_INCOMING_HostName,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_Port + ' = :CN_SETTINGS_EMAIL_INCOMING_Port,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_LoginName + ' = :CN_SETTINGS_EMAIL_INCOMING_LoginName,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_Password + ' = :CN_SETTINGS_EMAIL_INCOMING_Password,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_Security + ' = :CN_SETTINGS_EMAIL_INCOMING_Security,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_SSLMethod + ' = :CN_SETTINGS_EMAIL_INCOMING_SSLMethod,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_ServerType + ' = :CN_SETTINGS_EMAIL_INCOMING_ServerType,');

        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_GUID + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_GUID,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_ItemName + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_ItemName,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_Active + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_Active,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_HostName + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_HostName,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_Port + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_Port,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_LoginName + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_LoginName,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_Password + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_Password,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_Security + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_Security,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_INCOMING_VERCODE_ServerType + ' = :CN_SETTINGS_EMAIL_INCOMING_VERCODE_ServerType,');

        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_GUID + ' = :CN_SETTINGS_EMAIL_OUTGOING_GUID,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_ItemName + ' = :CN_SETTINGS_EMAIL_OUTGOING_ItemName,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_Active + ' = :CN_SETTINGS_EMAIL_OUTGOING_Active,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_HostName + ' = :CN_SETTINGS_EMAIL_OUTGOING_HostName,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_Port + ' = :CN_SETTINGS_EMAIL_OUTGOING_Port,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_LoginName + ' = :CN_SETTINGS_EMAIL_OUTGOING_LoginName,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_Password + ' = :CN_SETTINGS_EMAIL_OUTGOING_Password,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_Security + ' = :CN_SETTINGS_EMAIL_OUTGOING_Security,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_SSLMethod + ' = :CN_SETTINGS_EMAIL_OUTGOING_SSLMethod,');
        ADOQuery.SQL.Add(CN_SETTINGS_EMAIL_OUTGOING_ServerType + ' = :CN_SETTINGS_EMAIL_OUTGOING_ServerType,');

        ADOQuery.SQL.Add(CN_EMAIL_SENDER_ADDRESS + ' = :CN_EMAIL_SENDER_ADDRESS,');
        ADOQuery.SQL.Add(CN_EMAIL_FORWARD_ADDRESS + ' = :CN_EMAIL_FORWARD_ADDRESS,');
        ADOQuery.SQL.Add(CN_EMAIL_SUPPORT_ADDRESS + ' = :CN_EMAIL_SUPPORT_ADDRESS,');

        ADOQuery.SQL.Add(CN_AllBundleProductName + ' = :CN_AllBundleProductName');

        ADOQuery.SQL.Add('WHERE ' + CN_SETTINGS_VERSION + ' = ' + IntToStr(CURRENT_SETTINGS_VERSION));

        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_CHECK_INTERVAL').DataType := ftInteger;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_CHECK_INTERVAL').Value := SpinEditScanTimerMins.Value;

        //* Incoming orders
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_GUID').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_GUID').Value := GUIDToString(IncomingEmailAccount.GUID);
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_ItemName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_ItemName').Value := IncomingEmailAccount.ItemName;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_Active').DataType := ftBoolean;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_Active').Value := IncomingEmailAccount.Active;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_HostName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_HostName').Value := IncomingEmailAccount.HostName;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_Port').DataType := ftInteger;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_Port').Value := IncomingEmailAccount.Port;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_LoginName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_LoginName').Value := IncomingEmailAccount.LoginName;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_Password').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_Password').Value := StrEncode(IncomingEmailAccount.Password);
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_Security').DataType := ftWideString;
        case IncomingEmailAccount.Security of
            asNone: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_Security').Value := STR_EMAIL_ACCOUNT_SECURITY_NONE;
            asSSLTLS: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_Security').Value := STR_EMAIL_ACCOUNT_SECURITY_SSLTLS;
        end;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_SSLMethod').DataType := ftWideString;
        //* TODO: Newer Delphi versions (Indy mght add new options)
        case IncomingEmailAccount.SSLMethod of
            sslvSSLv2: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv2;
            sslvSSLv23: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv23;
            sslvSSLv3: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv3;
            sslvTLSv1: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1;
            sslvTLSv1_1: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_1;
            sslvTLSv1_2: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_2;
        end;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_ServerType').DataType := ftWideString;
        case IncomingEmailAccount.ServerType of
            asPOP3: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_ServerType').Value := STR_EMAIL_ACCOUNT_SERVER_TYPE_asPOP3;
            asIMAP: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_ServerType').Value := STR_EMAIL_ACCOUNT_SERVER_TYPE_asIMAP;
            asSMTP: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_ServerType').Value := STR_EMAIL_ACCOUNT_SERVER_TYPE_asSMTP;
        end;

        //* Version codes
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_GUID').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_GUID').Value := GUIDToString(IncomingEmailAccountVersionCodes.GUID);
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_ItemName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_ItemName').Value := IncomingEmailAccountVersionCodes.ItemName;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_Active').DataType := ftBoolean;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_Active').Value := IncomingEmailAccountVersionCodes.Active;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_HostName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_HostName').Value := IncomingEmailAccountVersionCodes.HostName;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_Port').DataType := ftInteger;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_Port').Value := IncomingEmailAccountVersionCodes.Port;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_LoginName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_LoginName').Value := IncomingEmailAccountVersionCodes.LoginName;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_Password').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_Password').Value := StrEncode(IncomingEmailAccountVersionCodes.Password);
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_Security').DataType := ftWideString;
        case IncomingEmailAccountVersionCodes.Security of
            asNone: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_Security').Value := STR_EMAIL_ACCOUNT_SECURITY_NONE;
            asSSLTLS: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_Security').Value := STR_EMAIL_ACCOUNT_SECURITY_SSLTLS;
        end;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod').DataType := ftWideString;
        //* TODO: Newer Delphi versions (Indy mght add new options)
        case IncomingEmailAccountVersionCodes.SSLMethod of
            sslvSSLv2: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv2;
            sslvSSLv23: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv23;
            sslvSSLv3: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv3;
            sslvTLSv1: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1;
            sslvTLSv1_1: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_1;
            sslvTLSv1_2: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_2;
        end;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_ServerType').DataType := ftWideString;
        case IncomingEmailAccountVersionCodes.ServerType of
            asPOP3: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_ServerType').Value := STR_EMAIL_ACCOUNT_SERVER_TYPE_asPOP3;
            asIMAP: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_ServerType').Value := STR_EMAIL_ACCOUNT_SERVER_TYPE_asIMAP;
            asSMTP: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_INCOMING_VERCODE_ServerType').Value := STR_EMAIL_ACCOUNT_SERVER_TYPE_asSMTP;
        end;

        //* Outgoing e-mail account
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_GUID').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_GUID').Value := GUIDToString(OutgoingEmailAccount.GUID);
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_ItemName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_ItemName').Value := OutgoingEmailAccount.ItemName;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_Active').DataType := ftBoolean;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_Active').Value := OutgoingEmailAccount.Active;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_HostName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_HostName').Value := OutgoingEmailAccount.HostName;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_Port').DataType := ftInteger;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_Port').Value := OutgoingEmailAccount.Port;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_LoginName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_LoginName').Value := OutgoingEmailAccount.LoginName;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_Password').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_Password').Value := StrEncode(OutgoingEmailAccount.Password);
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_Security').DataType := ftWideString;
        case OutgoingEmailAccount.Security of
            asNone: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_Security').Value := STR_EMAIL_ACCOUNT_SECURITY_NONE;
            asSSLTLS: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_Security').Value := STR_EMAIL_ACCOUNT_SECURITY_SSLTLS;
        end;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_SSLMethod').DataType := ftWideString;
        //* TODO: Newer Delphi versions (Indy mght add new options)
        case OutgoingEmailAccount.SSLMethod of
            sslvSSLv2: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv2;
            sslvSSLv23: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv23;
            sslvSSLv3: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv3;
            sslvTLSv1: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1;
            sslvTLSv1_1: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_1;
            sslvTLSv1_2: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_SSLMethod').Value := STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_2;
        end;
        ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_ServerType').DataType := ftWideString;
        case OutgoingEmailAccount.ServerType of
            asPOP3: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_ServerType').Value := STR_EMAIL_ACCOUNT_SERVER_TYPE_asPOP3;
            asIMAP: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_ServerType').Value := STR_EMAIL_ACCOUNT_SERVER_TYPE_asIMAP;
            asSMTP: ADOQuery.Parameters.ParamByName('CN_SETTINGS_EMAIL_OUTGOING_ServerType').Value := STR_EMAIL_ACCOUNT_SERVER_TYPE_asSMTP;
        end;

        ADOQuery.Parameters.ParamByName('CN_EMAIL_SENDER_ADDRESS').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_EMAIL_SENDER_ADDRESS').Value := EditSenderEmail.Text;
        ADOQuery.Parameters.ParamByName('CN_EMAIL_FORWARD_ADDRESS').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_EMAIL_FORWARD_ADDRESS').Value := EditForwardAddress.Text;
        ADOQuery.Parameters.ParamByName('CN_EMAIL_SUPPORT_ADDRESS').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_EMAIL_SUPPORT_ADDRESS').Value := EditSupportAddress.Text;

        ADOQuery.Parameters.ParamByName('CN_AllBundleProductName').DataType := ftWideString;
        ADOQuery.Parameters.ParamByName('CN_AllBundleProductName').Value := EditAllBundleProductName.Text;

        ADOQuery.ExecSql;

        Result := True;
    finally
        ADOQuery.SQL.Clear;
        ADOConnection.Close;
        Screen.Cursor := crDefault;
    end;
end;

function TFormSettings.LoadSettingsFromDataBase: Boolean;
var
    EmailCheckInterval: Integer;
    GUIDStr, SecurityStr, SSLMethod, ServerType: String;
begin

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.Close;
    ADOQuery.SQL.Clear;

    try

        //* Set to use our new database (specified by name)
        ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');
        //* Get all data
        ADOQuery.SQL.Add('SELECT * FROM ' + TN_SETTINGS + ' WHERE ' + CN_SETTINGS_VERSION + ' = ' + IntToStr(CURRENT_SETTINGS_VERSION));
        ADOQuery.Open;

        DataSource.DataSet.First;
        while NOT DataSource.DataSet.Eof do begin

            EmailCheckInterval := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_CHECK_INTERVAL).AsInteger;
            if EmailCheckInterval = 0 then begin
                SpinEditScanTimerMins.Value := 5;
            end else begin
                SpinEditScanTimerMins.Value := EmailCheckInterval;
            end;

            //* Incoming
            GUIDStr := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_GUID).AsWideString;
            if GUIDStr <> '' then begin
                IncomingEmailAccount.GUID := StringToGUID(GUIDStr);
            end;
            IncomingEmailAccount.ItemName := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_ItemName).AsWideString;
            IncomingEmailAccount.Active := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_Active).AsBoolean;
            IncomingEmailAccount.HostName := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_HostName).AsWideString;
            IncomingEmailAccount.Port := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_Port).AsInteger;
            if IncomingEmailAccount.Port = 0 then begin
                IncomingEmailAccount.Port := 995;
            end;
            IncomingEmailAccount.LoginName := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_LoginName).AsWideString;
            IncomingEmailAccount.Password := StrDecode(DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_Password).AsWideString);
            SecurityStr := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_Security).AsWideString;
            if SameText(SecurityStr, STR_EMAIL_ACCOUNT_SECURITY_NONE) then begin
                IncomingEmailAccount.Security := asNone;
            end else if SameText(SecurityStr, STR_EMAIL_ACCOUNT_SECURITY_SSLTLS) then begin
                IncomingEmailAccount.Security := asSSLTLS;
            //* Default value
            end else begin
                IncomingEmailAccount.Security := asSSLTLS;
            end;
            SSLMethod := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_SSLMethod).AsWideString;
            if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv2) then begin
                IncomingEmailAccount.SSLMethod := sslvSSLv2;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv23) then begin
                IncomingEmailAccount.SSLMethod := sslvSSLv23;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv3) then begin
                IncomingEmailAccount.SSLMethod := sslvSSLv3;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1) then begin
                IncomingEmailAccount.SSLMethod := sslvTLSv1;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_1) then begin
                IncomingEmailAccount.SSLMethod := sslvTLSv1_1;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_2) then begin
                IncomingEmailAccount.SSLMethod := sslvTLSv1_2;
            //* Default value
            end else begin
                IncomingEmailAccount.SSLMethod := sslvSSLv3;
            end;
            //* TODO: Newer Delphi versions (Indy mght add new options)
            ServerType := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_ServerType).AsWideString;
            if SameText(ServerType, STR_EMAIL_ACCOUNT_SERVER_TYPE_asPOP3) then begin
                IncomingEmailAccount.ServerType := asPOP3;
            end else if SameText(ServerType, STR_EMAIL_ACCOUNT_SERVER_TYPE_asIMAP) then begin
                IncomingEmailAccount.ServerType := asIMAP;
            end else if SameText(ServerType, STR_EMAIL_ACCOUNT_SERVER_TYPE_asSMTP) then begin
                IncomingEmailAccount.ServerType := asSMTP;
            //* Default value
            end else begin
                IncomingEmailAccount.ServerType := asPOP3;
            end;

            //* Incoming version code
            GUIDStr := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_GUID).AsWideString;
            if GUIDStr <> '' then begin
                IncomingEmailAccountVersionCodes.GUID := StringToGUID(GUIDStr);
            end;
            IncomingEmailAccountVersionCodes.ItemName := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_ItemName).AsWideString;
            IncomingEmailAccountVersionCodes.Active := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_Active).AsBoolean;
            IncomingEmailAccountVersionCodes.HostName := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_HostName).AsWideString;
            IncomingEmailAccountVersionCodes.Port := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_Port).AsInteger;
            if IncomingEmailAccountVersionCodes.Port = 0 then begin
                IncomingEmailAccountVersionCodes.Port := 995;
            end;
            IncomingEmailAccountVersionCodes.LoginName := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_LoginName).AsWideString;
            IncomingEmailAccountVersionCodes.Password := StrDecode(DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_Password).AsWideString);
            SecurityStr := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_Security).AsWideString;
            if SameText(SecurityStr, STR_EMAIL_ACCOUNT_SECURITY_NONE) then begin
                IncomingEmailAccountVersionCodes.Security := asNone;
            end else if SameText(SecurityStr, STR_EMAIL_ACCOUNT_SECURITY_SSLTLS) then begin
                IncomingEmailAccountVersionCodes.Security := asSSLTLS;
            //* Default value
            end else begin
                IncomingEmailAccountVersionCodes.Security := asSSLTLS;
            end;
            SSLMethod := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_SSLMethod).AsWideString;
            if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv2) then begin
                IncomingEmailAccountVersionCodes.SSLMethod := sslvSSLv2;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv23) then begin
                IncomingEmailAccountVersionCodes.SSLMethod := sslvSSLv23;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv3) then begin
                IncomingEmailAccountVersionCodes.SSLMethod := sslvSSLv3;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1) then begin
                IncomingEmailAccountVersionCodes.SSLMethod := sslvTLSv1;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_1) then begin
                IncomingEmailAccountVersionCodes.SSLMethod := sslvTLSv1_1;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_2) then begin
                IncomingEmailAccountVersionCodes.SSLMethod := sslvTLSv1_2;
            //* Default value
            end else begin
                IncomingEmailAccountVersionCodes.SSLMethod := sslvSSLv3;
            end;
            //* TODO: Newer Delphi versions (Indy mght add new options)
            ServerType := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_INCOMING_VERCODE_ServerType).AsWideString;
            if SameText(ServerType, STR_EMAIL_ACCOUNT_SERVER_TYPE_asPOP3) then begin
                IncomingEmailAccountVersionCodes.ServerType := asPOP3;
            end else if SameText(ServerType, STR_EMAIL_ACCOUNT_SERVER_TYPE_asIMAP) then begin
                IncomingEmailAccountVersionCodes.ServerType := asIMAP;
            end else if SameText(ServerType, STR_EMAIL_ACCOUNT_SERVER_TYPE_asSMTP) then begin
                IncomingEmailAccountVersionCodes.ServerType := asSMTP;
            //* Default value
            end else begin
                IncomingEmailAccountVersionCodes.ServerType := asPOP3;
            end;

            //* Outgoing
            GUIDStr := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_GUID).AsWideString;
            if GUIDStr <> '' then begin
                OutgoingEmailAccount.GUID := StringToGUID(GUIDStr);
            end;
            OutgoingEmailAccount.ItemName := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_ItemName).AsWideString;
            OutgoingEmailAccount.Active := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_Active).AsBoolean;
            OutgoingEmailAccount.HostName := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_HostName).AsWideString;
            OutgoingEmailAccount.Port := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_Port).AsInteger;
            if OutgoingEmailAccount.Port = 0 then begin
                OutgoingEmailAccount.Port := 465;
            end;
            OutgoingEmailAccount.LoginName := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_LoginName).AsWideString;
            OutgoingEmailAccount.Password := StrDecode(DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_Password).AsWideString);
            SecurityStr := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_Security).AsWideString;
            if SameText(SecurityStr, STR_EMAIL_ACCOUNT_SECURITY_NONE) then begin
                OutgoingEmailAccount.Security := asNone;
            end else if SameText(SecurityStr, STR_EMAIL_ACCOUNT_SECURITY_SSLTLS) then begin
                OutgoingEmailAccount.Security := asSSLTLS;
            //* Default value
            end else begin
                OutgoingEmailAccount.Security := asSSLTLS;
            end;
            SSLMethod := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_SSLMethod).AsWideString;
            if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv2) then begin
                OutgoingEmailAccount.SSLMethod := sslvSSLv2;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv23) then begin
                OutgoingEmailAccount.SSLMethod := sslvSSLv23;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvSSLv3) then begin
                OutgoingEmailAccount.SSLMethod := sslvSSLv3;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1) then begin
                OutgoingEmailAccount.SSLMethod := sslvTLSv1;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_1) then begin
                OutgoingEmailAccount.SSLMethod := sslvTLSv1_1;
            end else if SameText(SSLMethod, STR_EMAIL_ACCOUNT_SSL_METHOD_sslvTLSv1_2) then begin
                OutgoingEmailAccount.SSLMethod := sslvTLSv1_2;
            //* Default value
            end else begin
                OutgoingEmailAccount.SSLMethod := sslvSSLv3;
            end;
            //* TODO: Newer Delphi versions (Indy mght add new options)
            ServerType := DataSource.DataSet.FieldByName(CN_SETTINGS_EMAIL_OUTGOING_ServerType).AsWideString;
            if SameText(ServerType, STR_EMAIL_ACCOUNT_SERVER_TYPE_asPOP3) then begin
                OutgoingEmailAccount.ServerType := asPOP3;
            end else if SameText(ServerType, STR_EMAIL_ACCOUNT_SERVER_TYPE_asIMAP) then begin
                OutgoingEmailAccount.ServerType := asIMAP;
            end else if SameText(ServerType, STR_EMAIL_ACCOUNT_SERVER_TYPE_asSMTP) then begin
                OutgoingEmailAccount.ServerType := asSMTP;
            //* Default value
            end else begin
                OutgoingEmailAccount.ServerType := asSMTP;
            end;

            if DataSource.DataSet.FieldByName(CN_EMAIL_SENDER_ADDRESS).AsWideString <> '' then begin
                EditSenderEmail.Text := DataSource.DataSet.FieldByName(CN_EMAIL_SENDER_ADDRESS).AsWideString;
            end;
            if DataSource.DataSet.FieldByName(CN_EMAIL_FORWARD_ADDRESS).AsWideString <> '' then begin
                EditForwardAddress.Text := DataSource.DataSet.FieldByName(CN_EMAIL_FORWARD_ADDRESS).AsWideString;
            end;
            if DataSource.DataSet.FieldByName(CN_EMAIL_SUPPORT_ADDRESS).AsWideString <> '' then begin
                EditSupportAddress.Text := DataSource.DataSet.FieldByName(CN_EMAIL_SUPPORT_ADDRESS).AsWideString;
            end;

            if DataSource.DataSet.FieldByName(CN_AllBundleProductName).AsWideString <> '' then begin
                EditAllBundleProductName.Text := DataSource.DataSet.FieldByName(CN_AllBundleProductName).AsWideString;
            end;

            DataSource.DataSet.Next;
        end;
    finally
        ADOQuery.Close;
        ADOConnection.Close;
    end;
end;

end.
