//********************************************************************************************************************************
//*                                                                                                                              *
//*     TVersionUpdate 1.0  3delite 2008-2009                                                                                   *
//*     See TVersionUpdate.txt for details                                                                                       *
//*                                                                                                                              *
//* Two licenses are available if you like this component:                                                                       *
//* Shareware license: 15 Euros                                                                                                  *
//* Commercial license: 100 Euros                                                                                                *
//*                                                                                                                              *
//*     http://www.3delite.hu/Object Pascal Developer Resources/tversionupdate.html                                              *
//*                                                                                                                              *
//* If you have any of the aforementioned please email: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

unit VersionUpdateDefs;

interface

uses
  Classes, Windows, IdHTTP, ExtCtrls, SysUtils, Dialogs, Forms;

type
  TVersionUpdate = class(TComponent)
  private
    fURLVersionFile: String;
    fURLDownload: String;
    IdHTTPVersion: TIdHTTP;
    fHandle: THandle;
  public
    Constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
    function IsNewerVersionAvailable: Boolean;
    function IsNewerVersionAvailableDialog: Boolean;
  published
    property URLVersionFile: String read fURLVersionFile write fURLVersionFile;
    property URLDownload: String read fURLDownload write fURLDownload;
    property Handle: THandle read fHandle write fHandle;
end;

procedure Register;

implementation

Uses Helper3delite, ShellAPI, Controls;

procedure Register;
begin
    RegisterComponents('3delite', [TVersionUpdate]);
end;

constructor TVersionUpdate.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    IdHTTPVersion := TIdHTTP.Create(Self);
    IdHTTPVersion.ReadTimeout := 10 * 1000;
    fHandle := 0;
end;

Destructor TVersionUpdate.Destroy;
begin
    try
        FreeAndNil(IdHTTPVersion);
        inherited Destroy;
    except
        //*
    end;
end;

function TVersionUpdate.IsNewerVersionAvailable: Boolean;
var
  NewVerStr: String;
begin
    Result := False;
    try
        NewVerStr := IdHTTPVersion.Get(fURLVersionFile);
    except
        //*
    end;
    if IsNewerVersion(GetFileVersionStr(Application.ExeName), NewVerStr) then begin
        Result := True;
    end else begin
        Result := False;
    end;
end;

function TVersionUpdate.IsNewerVersionAvailableDialog: Boolean;
var
  Ver, NewVer, AppName, Company: String;
begin
    Result := IsNewerVersionAvailable;
    Ver := GetFileVersionStr(Application.ExeName);
    AppName := GetFileDescriptionStr(Application.ExeName);
    Company := GetFileAuthorStr(Application.ExeName);
    try
        NewVer := IdHTTPVersion.Get(fURLVersionFile);
    except
        //*
    end;
    if Result then begin
        if MessageDlg('New version available for ' + Company + '''s ' + AppName
            + (#13#10) + 'Current version: ' + Ver
            + (#13#10) + 'Newer version: ' + NewVer
            + (#13#10) + 'Do you want to download the update now?'
            , mtInformation, [mbYes, mbNo], 0) = mrYes then begin
            ShellExecute(fHandle, 'open', PChar(fURLDownload), nil, nil, SW_SHOWNORMAL);
        end;
    end else begin
        MessageDlg('No update available.', mtInformation, [mbOK], 0);
    end;
end;

end.
